*** 1st Draft scanner routine (based on other program) ***  

blox	ds.l 1  areg(1)
map	ds.l 1	areg(5)
ocmap	ds.l 1	areg(2)
visib	ds.l 1  areg(4)
chars	ds.l 1  areg(6)
x	ds.l 1  dreg(0)
y	ds.l 1	dreg(1)

start	move.l a6,chars
	move.l a4,visib	
	movea.l #0,a6	a6 has map pointer
	mulu #3,d1
	mulu #3,d0
	add d0,d1
	movea.l d1,a4	a4 holds OCMAP pointer 
	move #25,d1	d1 holds screen pointer
	move.l a1,blox
	move.l a2,ocmap
	move.l a5,map
	move.l #152,d7
	move #40,d0

block 	clr d3	
	move.l map,a5		a5 holds MAP memory location
	move.b (a5,a6),d3	d3 holds code of square 
	addi #4,d3		d3 now pointer to correct block 
	movea.l d3,a1
	
perck	movea.l ocmap,a2 
	clr d3
	move.b (a2,a4),d3	find if square ocupied
	bne prsn
	
loop	move.l d0,x	Protect corruptable registers
	move.l d1,y	

	clr d0		clear registers to prevent confusion
	clr d1
	clr d3
	clr d4

	move #9,d0	load registers with TRAP data
	move #1,d1
	move x,d2
	move y,d3
	move a1,d4
	 
	trap #5		execute TRAP, SPRITE

	clr d1		clear registers fo PUT SPRITE
	clr d0
	
	move #35,d0	load registers with data
	move #1,d1
	
	trap #5		execute TRAP, PUT SPRITE
	
	move x,d0	restore protected data
	move y,d1

end	addq #3,d0
	addq #1,a6
	addq #3,a4
	cmpi #280,d0
	bne block
	addi #3,d1
	move #40,d0
	cmpi #175,d1
	bne block
	rts		

prsn	clr d2		Person instead of graphic block
	clr d6
	addq #1,a2	find UNIT
	move.b (a2,a4),d2
	addq #1,a2	find FACING
	move.b (a2,a4),d6
	subq #1,d3	find TEAM
	mulu #20,d3
	subq #1,d2
	add d2,d3
	movea.l visib,a2	a2 now VISIB 
	adda d3,a2
	sub d2,d3
	clr d2
	move.b (a2),d2	check defined person is VISIB	
	beq loop

displ	divu #20,d3
	addi #3,d3 	
	bra loop
 